function sed_android {
  if [ -z $android ]; then
    return
  fi

  android_split=($(echo $android | tr "/" "\n"));

  if [ ${#android_split[@]} -eq 2 ]; then
    android_n=${android_split[1]};
    echo "Update android SDK version : ${android_split[0]} -> ${android_split[1]}";
    sed -i '' "s/$android/g" ./android/build.gradle
  else
    echo "android version format is not valid";
    echo " ex) <old version>/<new version";
  fi
}

function sed_ios {
  if [ -z $ios ]; then
    return
  fi

  ios_split=($(echo $ios | tr "/" "\n"));

  if [ ${#ios_split[@]} -eq 2 ]; then
    ios_n=${ios_split[1]};
    echo "Update ios SDK version : ${ios_split[0]} -> ${ios_split[1]}";
    sed -i '' "s/$ios/g" ios/airbridge_flutter_sdk.podspec
  else
    echo "ios version format is not valid";
    echo " ex) <old version>/<new version";
  fi
}

function check_chnagelog {
  grep -q "$chagelog" changelog.md; echo $?
  #[ $? -eq 0 ] && echo 1 || echo 0
}

function sed_chnagelog {
  if [ -z $version ]; then
    return
  fi

  version_split=($(echo $version | tr "/" "\n"));

  if [ ! ${#version_split[@]} -eq 2 ]; then
    echo "sdk version format is not valid";
    echo " ex) <old version>/<new version";
    return
  fi

  sed -i '' "s/$version/g" pubspec.yaml
  sed -i '' "s/$version/g" lib/src/interface/web_interface_impl.dart

  chagelog="## ${version_split[1]}"

  result=$(check_chnagelog);
  if [ $result == '0' ]; then
    echo "changelog.md had ${version_split[1]}";
    return
  fi

  echo "Update react-native SDK vesion : ${version_split[0]} -> ${version_split[1]}";
  
  chagelog+="\n\n"
  if [ -z $android_n ] && [ -z $ios_n ]; then
    chagelog+="\n"
  else
    chagelog+="**FIXED**\n";
    if [ ! -z $android_n ]; then
      chagelog+="* Update \`Airbridge Android SDK\` to $android_n\n";
    fi

    if [ ! -z $ios_n ]; then
      chagelog+="* Update \`Airbridge iOS SDK\` to $ios_n\n";
    fi
    chagelog+="\n"
  fi

  sed -i '' "1s/^/$chagelog/" changelog.md
}

while getopts v:a:i: flag
do
    case "${flag}" in
        v) version=${OPTARG};;
        a) android=${OPTARG};;
        i) ios=${OPTARG};;
    esac
done

if [ -z $version ]; then
  echo "version may not be null";
  exit 1;
fi

android_n=""
ios_n=""

sed_android;
sed_ios;
sed_chnagelog;
